# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/mXX_01_Experiment.py
"""
Dokumentační komentář modulu.
"""

s = dict()
import collections.abc
m = collections.abc.Mapping()

#Výpis 22.1: Popisek
############################################################################
# >>> \
class Shape:
    """Třída obecných geometrických tvarů se zadanou pozicí."""
    count = 0
    def __init__(self, *, x=0, y=0):
        print(f"Shape - START {x=}, {y=}")
        Shape.count += 1
        self.ID = Shape.count
        self.x = x;   self.y = y
        print(f"Shape - KONEC {self.x=}, {self.y=}")
    def move(self, dx, dy):   self.x += dx;   self.y += dy
    def __repr__(self):
        return f"{self.__class__.__name__}{self.ID}_" \
               f"{self.__dict__}"

# >>> \
class Rectangle(Shape):
    """Třída čtverců."""
    def __init__(self, *, x=0, y=0, side=1):
        print(f"Rectangle - START {x=}, {y=}, {side=}")
        super().__init__(x=x, y=y)
        self.side = side
        print(f"Rectangle - KONEC {self.x=}, {self.y=}, {self.side=}")
    def size(self):
        return self.side * self.side

# >>> \
class Circle(Shape):
    """Třída kruhů."""
    def __init__(self, *, x=0, y=0, radius=1):
        print(f"Circle - START {x=}, {y=}, {radius=}")
        super().__init__(x=x, y=y)
        self.radius = radius
        print(f"Circle - KONEC {self.x=}, {self.y=}, {self.radius=}")
    def size(self):
        from math import pi
        return pi * self.radius * self.radius



#Výpis 22.1: Popisek
############################################################################
# >>> \
class Matka (object):
    cls_atr = "Matka_Atr_Třídy"
    @staticmethod
    def clsmtd():   print('Matka - statická metoda')
    def mtd(self):  print('Matka ')



#Pomocné
############################################################################

# >>> \
def sign(inst):
    """Vrátí řetězec s podpisem zadaného objektu
       a jeho rodičovských podobjektů."""
    mro = inst.__class__.__mro__
    lst = []
    for cls in mro:
        print(f"{(su:=super(cls, inst))}")
        su.mtd()
        lst.append(su)
    return lst


# >>> \
def init(cls, inst):
    n = cls.__name__
    print(f'{n}.__init__() - START')
    super(cls, inst).__init__()
    cls.count += 1
    inst.ID = cls.count
    inst.iatr = n + '_Ins_dat'
    print(f'{n}.__init__() - KONEC: ' \
          f'{cls.count=}, {inst.ID=}, {inst.iatr=}')




#Kaptitola 22: Dědění
############################################################################

# >>> \
class A:
    count = 0
    catr  = 'A_Cls_dat'
    def __init__(self):
        print('A.__init__() - START')
        A.count += 1;
        self.ID = A.count
        self.iatr = 'A_Ins_dat'
        print('A.__init__() - KONEC')
    def mtd(self): print ('A_Ins_mtd')
    def __repr__(self): return f"A_{self.ID}({self.iatr=})"

# >>> \
class B(A):
    count = 0
    catr  = 'B_Cls_dat'
    def __repr__(self): return f"B_{self.ID}({self.iatr=}; {super().__repr__()})"
    def __init__(self): init(B, self)
    def mtd(self): print ('B_Ins_mtd')

        # super().__init__()
        # B.count += 1;
        # self.IDB = B.count
        # self.iatr = 'B_Ins_dat'

# >>> \
class C(B):
    count = 0
    catr  = 'C_Cls_dat'
    def __repr__(self): return f"C_{self.ID}({self.iatr=}; " \
                               f"{super().__repr__()})"
    def __init__(self): init(C, self)
    def mtd(self): print ('C_Ins_mtd')

        # super().__init__()
        # B.count += 1;
        # self.IDB = B.count
        # self.iatr = 'B_Ins_dat'


# >>> \
class C(B):
    count = 0
    catr  = 'C_Cls_dat'
    def __repr__(self): return f"C_{self.IDB}({self.iatr=})"
    def __init__(self):
        init(B, self)
    def mtd(self): print ('C_Ins_mtd')

b = B();   b.mtd()
# Přebíjející
A.mtd(b)
# Přebitá
b.atr,   b.super().atr
# >>>


############################################################################
# >>> \
class P:    # Parent = rodič
    z = "Hello"
    def set_p  (self):  self.x = "Class P"
    def print_p(self):  print(self.x)

# >>> \
class C(P): # Child = potomek
    def set_c  (self):   self.x = "Class Ca"
    def print_c(self):   print(self.x)

c = C();   c.set_p();   c.print_p();   c.print_c()
# Class P
# Class P
c.set_c();   c.print_c();   c.print_p()
# Class Ca
# Class Ca
c.z,   C.z,   P.z

############################################################################

class First(object):
    def __init__(self):
        print("first")

class Second(First):
    def __init__(self):
        print("second")

class Third(First):
    def __init__(self):
        print("third")

class Fourth(Second, Third):
    def __init__(self):
        super(Fourth, self).__init__()
        print("that's it")

f = Fourth()

############################################################################

class FirstS(object):
    def __init__(self):
        super(FirstS, self).__init__()
        print("FirstS")

class SecondS(FirstS):
    def __init__(self):
        super(SecondS, self).__init__()
        print("SecondS")

class ThirdS(FirstS):
    def __init__(self):
        super(FirstS, self).__init__()
        print("ThirdS")

class FourthS(SecondS, ThirdS):
    def __init__(self):
        super(FourthS, self).__init__()
        print("FourthS: that's it")

fs = FourthS()

############################################################################

class First(object):
    def __init__(self):
        super(First, self).__init__()
        print("first")


class Second(object):
    def __init__(self):
        super(Second, self).__init__()
        print("second")


class Third(First, Second):
    def __init__(self):
        super(Third, self).__init__()
        print("third")

############################################################################

class Shape:
    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y

class Square(Shape):
    def __init__(self, side=1, x=0, y=0):
        super().__init__()
        self.side = side

class Circle(Shape):
    def __init__(self, r=1, x=0, y=0):
        super().__init__(x, y)
        self.radius = r

############################################################################


# >>> \
class R1:
    def __init__(self):  print('Inicializuje se R1')

# >>> \
class R2:
    def __init__(self):  print('Inicializuje se R2')

# >>> \
class P(R1, R2):
    def __init__(self):
        print('Start inicializace P')
        super.__init__(self)
        print('Konec inicializace P')



#Kaptitola 21: Třídy a jejich instance
############################################################################
# >>> \
class Exp0:
    """Experimentárlní třída pro demo lokality atributů."""

    ca = 'Globální'

    def __init__(self, ca = None):
        """Není-li zadán argument ca, přebírá se třídní."""
        if (ca):  self.ca = ca

    def get_ca(self):
        """Vrací aktuálně platnou hodnotu ca - instanční či třídní."""
        return self.ca

    def __repr__(self):
        """Převod instance na text používaný systémem."""
        return f'<Exp01: {self.ca=}>'

(e00 := Exp0()).ca,   (e01 := Exp0('Lokální')).ca
# ('Globální', 'Lokální')
e00, e01
# (<Exp01: self.ca='Globální'>, <Exp01: self.ca='Lokální'>)
print((e00, e01))


# >>> \
class Exp1:
    count = 0
    def __init__(self, i):
        Exp1.count +=1
        self.ID = Exp1.count
        def m(self): return f'Metoda {i} instance {self}'
        Exp1.mm = m
        self.mtdi = Exp1.mm
    def __repr__(self): return f'<Exp1_{self.ID}>'

(e10:=Exp1(10), e11:=Exp1('XI'))
# (<Exp1_1>, <Exp1_2>)
e10.mtdi(),   e11.mtdi()

def X(self): return f'Metoda X instance {self}'

e10.mx = X
e10.mx()
del e10.mx;   Exp1.mx = X
e10.mx()




e10 = Exp1();   e11 = Exp1()
e10.mtd = e10.mtd1;   e11.mtd = e11.mtd2
e10.mtd()
# ('Globální', 'Lokální')
e00, e01
# (<Exp01: self.ca='Globální'>, <Exp01: self.ca='Lokální'>)
print((e00, e01))

def mtd3(self): return f'Volána mtd3 instance {self}'


#Kaptitola xx: ???
############################################################################

_local = 'Lokální'

print( '===== START načítání modulu', __name__, '=====')

la = [1, 2];  lb = [10, 20]
(lab := la + lb)
print(f"{la=}, {lb=}, {lab=}")  
      
class imm:
    def __init__(self, text):
        self.text = text
    def __str__(self):
        return self.text
    def __repr__(self):
        return self.text

str(imm('a'))


def g3L(n):
    for i in range(n):
        yield [10+i, 20+i, 30+i]

for x, y, z in g3L(1): print("x=", x, ", y=", y, ", z=", z, sep='')

for x, y, z in g3L(3): print("x=", x, ", y=", y, ", z=", z, sep='')

def g3S(n):
        for i in range(n):
            yield {10+i, 20+i, 30+i}

for s in g3S(1): print("s=", s)

for x, y, z in g3S(3): print("x=", x, ", y=", y, ", z=", z, sep='')




print('===== KONEC načítání modulu''', __name__, '=====')
