#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m00_##_Šablona_modulu.py
"""
Dokumentační komentář modulu.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 2.8: Pyramid - functools.update_wrapper
############################################################################
WRAPPER_ASSIGNMENTS = ('__module__', '__name__', '__doc__')
WRAPPER_UPDATES = ('__dict__',)

def update_wrapper(wrapper, wrapped,
                   assigned = WRAPPER_ASSIGNMENTS,
                   updated = WRAPPER_UPDATES):
    """Update a wrapper function to look like the wrapped function
    wrapper is the function to be updated
    wrapped is the original function
    assigned is a tuple naming the attributes assigned directly
            from the wrapped function to the wrapper function
            (defaults to functools.WRAPPER_ASSIGNMENTS)
    updated is a tuple naming the attributes of the wrapper that are
            updated with the corresponding attribute from the wrapped
            function (defaults to functools.WRAPPER_UPDATES)
    """
    for attr in assigned:
        setattr(wrapper, attr, getattr(wrapped, attr))
    for attr in updated:
        getattr(wrapper, attr).update(getattr(wrapped, attr, {}))
        # Return the wrapper so this can be used as a decorator via partial()
    return wrapper

def wraps(wrapped,
          assigned = WRAPPER_ASSIGNMENTS,
          updated = WRAPPER_UPDATES):
    """Decorator factory to apply update_wrapper() to a wrapper function
    Returns a decorator that invokes update_wrapper() with the decorated
    function as the wrapper argument and the arguments to wraps() as the
    remaining arguments. Default arguments are as for update_wrapper().
    This is a convenience function to simplify applying partial()
    to update_wrapper().
    """
    return partial(update_wrapper, wrapped=wrapped, assigned=assigned,
                   updated=updated)

def partial(func, *args, **keywords):
    """Return a new partial object which when called will behave like
    func called with the positional arguments args and keyword arguments
    keywords. If more arguments are supplied to the call, they are appended
    to args. If additional keyword arguments are supplied,
    they extend and override keywords.
    """
    def newfunc(*fargs, **fkeywords):
        newkeywords = keywords.copy()
        newkeywords.update(fkeywords)
        return func(*(args + fargs), **newkeywords)
    newfunc.func = func
    newfunc.args = args
    newfunc.keywords = keywords
    return newfunc
# print('===== KONEC načítání modulu', __name__, '=====')
